********************************************************************************
*                                                                              *
*  2DHF version 5-2005                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### plegendg ###		  	    
c
c
      function plegendg(l,m,costh)
      implicit integer*4 (i-n)
      parameter (ione=1)
      implicit real*8 (a-h,o-z)		
      include 'commons8.inc'

      ct=abs(1.0-costh*costh)

      if (m.eq.0) then
         plegendg=hypgf3(-l,l+1,ione,(1.0-costh)/2.0)
      elseif (m.ne.0.and.ct.lt.precis) then           
         plegendg=0.0
      else
         fn0=(-1.0**(m))*factor(l+m)/factor(l-m)
     &        /factor(m)/(2.0**(m))
         ct1=fn0*ct**((m)/2.0)	   
         plegendg=hypgf3(m-l,m+l+1,m+1,(1.0-costh)/2.0)*ct1
      endif
      return
      end
