c ### setconst ###
c
c     Set some constants.
c
c     Warning! This routine must be compiled with the minimum
c     optimization on x86 systems to avoid reporting precision of the
c     extended IEEE 754 arithmetic.
 
      subroutine setconst
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

c pi from bc -l
c    scale=32
c    a(1)*4=           3.14159265358979323846264338327948
c    scale=64
c    a(1)*4=           3.14159265358979323846264338327950

      pii=atan(one)*four

      t=one
      do i=1,10000
         t=t/two
         o=one+t
c         print *,'i,t',i,t
         if ( o.eq.one) goto 100
      enddo
 100  continue
      precis=t

c     set default lengths of integer and real constants and variables used

      i8tmp1=2**31
      i8tmp2=100000*i8tmp1
      i4tmp1=i8tmp2
      if (i4tmp1.eq.0) then
         lengthint=4
      else
         lengthint=8
      endif   

      if (precis.gt.1e-20) then
         lengthfp =8
      else
         lengthfp =16
      endif
      return
      end
