********************************************************************************
*                                                                              *
*  2DHF version 5-2005                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inpf ###
c
c     Extracts a floating point number from an input card.
c
      subroutine inpf(buf)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (i40=40, i80=80)
      character*1 ia,ichar(16),itemp
      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(i40),inumb(i40),ia(i80)
      data ichar/'0','1','2','3','4','5','6','7','8','9','+','&','^',
     &'-','.','e'/


      limit=16
      jrec = jrec + 1
      if(jrec .gt. jump) return
      buf = 0.d0
      fact2 = 0.d0
      iexp=0
      n = inumb(jrec)
      fact = 1.d0
      ist=istrt(jrec)
      nstrt = ist + n - 1
      iexpdig=0
      do i=1,n
         itemp = ia(nstrt)
         do j = 1,limit
            if(ichar(j).eq.itemp) goto 5
         enddo

 4       write(iout6,*) 'Error detected in inpf'
         stop 'inpf' 

 5       continue
         if (j.eq.16) goto 12
         if (j.lt.11) goto 7
         if (j.le.14) goto 6
         if (iexp.eq.1) then
            fact2 = dble(i-1-iexpdig)
         else
            fact2 = dble(i-1)
         endif
         go to 9

 12      continue
         if (iexp.eq.0) then
            buf=(0.1d0**fact2)*buf
            exponent=buf
            iexp=1
            buf=0
            fact=1.0
            fact2=0.0
            iexpdig=i
         endif
         goto 9

 15      continue
         buf = buf + dble(j-1) * fact
         fact=fact*10.d0
         goto 9

 6       continue
c         if(nstrt.ne.ist.and.iexp.eq.0) go to 4
         if(j.eq.14) buf=-buf
         goto 9

 7       buf = buf + dble(j-1) * fact
         fact=fact*10.d0
 9       continue
         nstrt = nstrt - 1
      enddo

      if (iexp.eq.1) then
         buf=(0.1d0**fact2)*buf
         buf=buf*10.d0**exponent
         return
      endif
 20   buf=(0.1d0**fact2)*buf
      return

      end
